/* How do you control a dog? Use a leash!	*/
/* This is a library for controlling		*/
/* Electronic Assembly's DOG series			*/
/* graphic LCD displays, as well as the 	*/	
/* Nokia 3310 one. 							*/
/* Written by PaNiC @ elektronikforumet.com	*/
/* Drawing functions written by Korken		*/

#include "leash.h"
#include "lcdfont.h"


void SPI_init(void){
	
#ifdef SPI_S

	SPI_DDR |= (1 << DO) | (1 << CLK) | ~(1 << DI);		
	RST_DDR |= (1 << RST_PIN);
	CS1_DDR |= (1 << CS1_PIN);
	CS2_DDR |= (1 << CS2_PIN);
	CD_DDR |= (1 << CD_PIN);
	SPI_SETCLK;		

#endif

#ifdef SPI_H
	SPI_DDR |= (1 << DO) | (1 << CLK) | ~(1 << DI);		
	RST_DDR |= (1 << RST_PIN);
	CS1_DDR |= (1 << CS1_PIN);
	CS2_DDR |= (1 << CS2_PIN);
	CD_DDR |= (1 << CD_PIN);
	SPCR = 0b01011100; 
#endif


/*
SPI_DDR |= (1 << DO) | (1 << CLK) | ~(1 << DI);		
RST_DDR |= (1 << RST_PIN);
CS_DDR |= (1 << CS_PIN);
CD_DDR |= (1 << CD_PIN);
SPCR = 1<<SPE | 1<<MSTR | 1<<CPOL | 1<<CPHA | 1<<SPR0;
*/


}


void SPI_send(char data){			
  
#ifdef SPI_S

 	unsigned char i = 0;
	for(i=0;i<8;i++){
		if(data & 0b10000000){
		SPI_SETDO;
		}	
		else SPI_CLEARDO;

	SPI_CLEARCLK;					
	SPI_SETCLK;						
	data = data << 1;
	}
#endif



#ifdef SPI_H


	SPDR = data;

while ( !(SPSR & 0x80) );    //  Wait until Tx register empty.
	

#endif





/*
	SPDR = data;
	while ( !(SPSR & 0x80) );
*/
}


void LCD_writecmd(char cmd, char displayno){		
	LCD_CLEARDATA;
	switch(displayno){
	case 1: LCD_SELECT1;
			break;
	case 2: LCD_SELECT2;
			break;
	}
	SPI_send(cmd);
	switch(displayno){
	case 1: LCD_DESELECT1;
			break;
	case 2: LCD_DESELECT2;
			break;
	}
}


void LCD_writedata(char data, char displayno){		
	LCD_SETDATA;
	switch(displayno){
	case 1: LCD_SELECT1;
			break;
	case 2: LCD_SELECT2;
			break;
	}
	SPI_send(data);
	switch(displayno){
	case 1: LCD_DESELECT1;
			break;
	case 2: LCD_DESELECT2;
			break;
	}
	LCD_CLEARDATA;
}


void LCD_setxy(char x, char y, char displayno){		

#ifdef CFAL12832
	x+=2;		/* This display starts at segment 2, not 0. */
#endif


#if defined(DOGS) || defined(DOGM) || defined (DOGL) || defined (CFAL12832)
	char xlow = (x & 0b00001111);
	x = (x >> 4);
	char xhigh = (x & 0b00001111);
#endif

#if defined(DOGS) || defined(DOGM) || defined (DOGL) || defined (CFAL12832)	
	LCD_writecmd(xlow | 0b00000000, displayno);
	LCD_writecmd(xhigh | 0b00010000, displayno);
#endif

#if defined(DOGS) || defined(DOGM) || defined (DOGL) || defined (CFAL12832)
	LCD_writecmd(y | 0b10110000, displayno); // for DOGS
#endif

#ifdef DOGXL
	LCD_writecmd(y | 0b01100000, displayno); // for DOGXL
#endif

#ifdef N3310

    LCD_writecmd (0x80 | x, displayno);   //column
	LCD_writecmd (0x40 | y, displayno);   //row

#endif

}


void FB_setxy(char x, char y){		
	FB_xpos = x;
	FB_ypos = y;
}


void LCD_clear(char displayno){					
	unsigned char x = 0;
	unsigned char y = 0;	
	for(y = 0; y < LCD_Y/8; y++){
		LCD_setxy(0,y,displayno);
		for(x = 0; x < LCD_X; x++){
		LCD_writedata(0x00, displayno);
		}
	}
}


void FB_clear(void){					
	unsigned char x = 0;
	unsigned char y = 0;	
	for(y = 0; y < LCD_Y/8; y++){
		FB_setxy(0,y);
		for(x = 0; x < LCD_X; x++){
		FB_writedata(0x00);
		}
	}
}


void LCD_update(char displayno){	
	unsigned char y = 0;
	unsigned char x = 0;
	for(y = 0; y < LCD_Y/8; y++){
		LCD_setxy(0,y, displayno);
		for(x = 0; x < LCD_X; x++){
		LCD_writedata(fb[x][y], displayno);
		}

	}
}


void FB_writechar(unsigned char x, unsigned char y, char ch)
{   

 char ch_data[5] = {0, 0, 0, 0, 0};

   

   if(ch != ' ') FB_clearrect(x,y,x+5,y+7);
   if (ch == ' '){
      FB_xpos += 4;
	  FB_clearrect(x,y,x+4,y+7);
      FB_setxy(x+4,y);
      return; 
   }
   if(ch == '1'){
	  x += 1;
   }
   if(ch == 'I'){
  	  x += 1;
   }
   if(ch == 'i'){
      x += 1;
   }



	ch_data[0] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 0]));
	ch_data[1] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 1]));
	ch_data[2] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 2]));
	ch_data[3] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 3]));
	ch_data[4] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 4]));
   //if (ch_data[0] != 0)
   //{
      for(unsigned char a = 0; a < sizeof(ch_data); a++)
      {
         for(unsigned char i = 8; i > 0; i--)
         {
            if ((ch_data[a] == 0) || ((x + a) == 127))
              break;
               
            if (ch_data[a] & 0x80)
               FB_drawdot((x + a), (y + i));
               
            ch_data[a] <<= 1;
         }
      }
   //}
}

void FB_writecharbig(unsigned char x, unsigned char y, char ch)
{   

 char small_data[5] = {0, 0, 0, 0, 0};
 int big_data[5] = {0, 0, 0, 0, 0};

   

   if(ch != ' ') FB_clearrect(x,y,x+10,y+14);
   if (ch == ' '){
      FB_xpos += 4;
	  FB_clearrect(x,y,x+8,y+14);
      FB_setxy(x+8,y);
      return; 
   }
   if(ch == '1'){
	  x += 2;
   }
   if(ch == 'I'){
  	  x += 2;
   }
   if(ch == 'i'){
      x += 2;
   }

	small_data[0] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 0]));
	small_data[1] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 1]));
	small_data[2] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 2]));
	small_data[3] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 3]));
	small_data[4] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 4]));

	for(signed char j=0; j<5; j++){
	
		for(signed char i=7; i>=0; i--){
			big_data[j] <<=2;
			if(small_data[j] & 1<<i) big_data[j] |=3;
		}
	
	}


   for(unsigned char a = 0; a < 5; a++)
      {
	      
		     for(unsigned char i = 16; i > 0; i--)
	         {
	            if ((big_data[a] == 0) || ((x + a) == 32767))
	              break;
               
	            if (big_data[a] & 0b1000000000000000){
	            	FB_drawdot((x + a*2), (y + i));
               		FB_drawdot((x+a*2+1), (y + i ));
				}
	            big_data[a] <<= 1;
	         }
		
		
      }



}







void FB_writestringprogmem(unsigned char x, unsigned char y, char *s)
{
   unsigned char i = 0;
   
   while(pgm_read_byte(&(s[i])))
   {
	 if((pgm_read_byte(&(s[i])) < 199)){
  	    FB_writechar(x, y, pgm_read_byte(&(s[i])));
  	    x = (FB_xpos + 1);
      
  	    if (FB_xpos == LCD_X)
  	    {
  	       return;
  	    }
      
	} 
     i++;
  	
   }
}

void FB_writestringram(unsigned char x, unsigned char y, char *s)
{
   unsigned char i = 0;
   
   while(s[i])
   {
	 if((s[i] < 199)){
  	    FB_writechar(x, y, s[i]);
  	    x = (FB_xpos + 1);
      
  	    if (FB_xpos > LCD_X)
  	    {
  	       return;
  	    }
      
	} 
     i++;
  	
   }
}



void FB_writestringrambig(unsigned char x, unsigned char y, char *s)
{
   unsigned char i = 0;
   
   while(s[i])
   {
	 if((s[i] < 199)){
  	    FB_writecharbig(x, y, s[i]);
  	    x = (FB_xpos + 2);
      
  	    if (FB_xpos > LCD_X)
  	    {
  	       return;
  	    }
      
	} 
     i++;
  	
   }
}




/* 
void FB_writechar(char data){

	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 0])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 1])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 2])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 3])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 4])));
	FB_writedata(0x00);
}
*/

void FB_writedata(char data){		
	fb[FB_xpos][FB_ypos] = data;
	FB_xpos++;
}

/*
void FB_writestring(char *s)
{
	unsigned char i = 0;
	while(s[i]){
	FB_writechar(s[i]);
	i++;
	}


}
*/
void FB_drawpat(char pat, char count){
	unsigned char i = 0;
	for(i = 0; i < count; i++){
		FB_writedata(pat);
	}
}

void FB_clearrect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2)
{
   for(int y = y1; y <= y2; y++)
   {
      for (int x = x1; x <= x2; x++)
      {
      FB_cleardot(x,y);   
      }
   }
}

#if defined(DOGS) || defined(DOGM) || defined(DOGL) || defined(DOGXL) || defined CFAL12832

void LCD_init(void){
	CS1_DDR |= (1 << CS1_PIN);
	CS2_DDR |= (1 << CS2_PIN);
	CD_DDR |= (1 << CD_PIN);
	RST_DDR |= (1 << RST_PIN);
	RST_PORT |= (1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT &= ~(1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT |= (1 << RST_PIN);

#endif

#ifdef N3310

void LCD_init(char contrast, char neg){
	CS1_DDR |= (1 << CS1_PIN);
	CS2_DDR |= (1 << CS2_PIN);
	CD_DDR |= (1 << CD_PIN);
	RST_DDR |= (1 << RST_PIN);
	RST_PORT |= (1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT &= ~(1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT |= (1 << RST_PIN);

#endif


#ifdef CFAL12832
for(unsigned char i = 1; i < 2; i++){
	LCD_writecmd(0xAE, i);			/* Set display off */
	LCD_writecmd(0xD5, i);			/* Set clock divide ratio */
	LCD_writecmd(0xF0, i);			/* Set oscillator frequency */
	LCD_writecmd(0xA8, i);			/* Set multiplex ratio */
	LCD_writecmd(0x1F, i);			/* Set multiplex ratio */
	LCD_writecmd(0xD3, i);			/* Set display offset */
	LCD_writecmd(0x00, i);			/* Set display offset */
	LCD_writecmd(0x40, i);			/* Set display start line */
	LCD_writecmd(0xAD, i);			/* Set master configuration */
	LCD_writecmd(0x8E, i);			/* Set master configuration */
	LCD_writecmd(0xD8, i);			/* Set area colour mode off */
	LCD_writecmd(0x05, i);			/* Set low power mode */
	LCD_writecmd(0xA1, i);			/* Set segment remap */
	LCD_writecmd(0xC8, i);			/* Set COM output scan direction */
	LCD_writecmd(0xDA, i);			/* Set COM pins hardware config */
	LCD_writecmd(0x12, i);			/* Set COM pins hardware config */
	LCD_writecmd(0x91, i);			/* Set lookup table  */
	LCD_writecmd(0x3F, i);			/* Set lookup table */
	LCD_writecmd(0x3F, i);			/* Set lookup table */
	LCD_writecmd(0x3F, i);			/* Set lookup table */
	LCD_writecmd(0x3F, i);			/* Set lookup table */
	LCD_writecmd(0x81, i);			/* Set current control for bank0 */
	LCD_writecmd(0x80, i);			/* Set current control for bank0 */
	LCD_writecmd(0xD9, i);			/* Set pre-charge period */
	LCD_writecmd(0xF1, i);			/* Set pre-charge period */
	LCD_writecmd(0xDB, i);			/* Set VCOMH deselect level */
	LCD_writecmd(0x34, i);			/* Set VCOMH deselect level */
	LCD_writecmd(0xA4, i);			/* Set entire display off */
	LCD_writecmd(0xA6, i);			/* Set normal/inverse to normal */
	LCD_clear(i);					/* Clear display memory */
	LCD_writecmd(0xAF, i);			/* Set display on */
}

#endif
	
//	LCD_writecmd(0b11110001);
//	LCD_writecmd(0b01100111); /* Set last COM electrode to 103 */
//	LCD_writecmd(0b11000000); /* SEG and COM normal */
//	LCD_writecmd(0b01000000);
//	LCD_writecmd(0b01010000); /* Start line at 0 */
//	LCD_writecmd(0b00101011); /* Panel loading at 28..38nF */
//	LCD_writecmd(0b11101011); /* 1/12 bias */
//	LCD_writecmd(0b10000001); 
//	LCD_writecmd(0b01011111); /* Set contrast */
//	LCD_writecmd(0b10001001); /* Set auto increment */
//	LCD_writecmd(0b10101111); /* Display ON */ 
//	LCD_writecmd(0b10100100);
/* Above is for DOGXL display */

#ifdef DOGS
for(unsigned char i = 1; i < 2; i++){
	LCD_writecmd(0b01000000, i); /* Set start line 0 */
	LCD_writecmd(0b10100001, i); /* SEG reverse */
	LCD_writecmd(0b11000000, i); /* COM normal */
	LCD_writecmd(0b10100100, i); /* Pixels ON? */
	LCD_writecmd(0b10100110, i); /* INV off */
	LCD_writecmd(0b10100010, i); /* 1/9 bias */
	LCD_writecmd(0b00101111, i); /* Booster, regulator, follower ON */
	LCD_writecmd(0b00100111, i); /* Contrast */
	LCD_writecmd(0b10000001, i); /* Contrast */
	LCD_writecmd(0b00000110, i); /* Contrast */
	LCD_writecmd(0b11111010, i); /* Temp compensation */
	LCD_writecmd(0b10010000, i); /* Temp compensation */
	LCD_writecmd(0b10101111, i); /* Display ON */
/* Above is for DOGS display */
}
#endif

#ifdef DOGL
for(unsigned char i = 1; i < 2; i++){
	LCD_writecmd(0b01000000, i); /* Set start line 0 */
	LCD_writecmd(0b10100001, i); /* SEG reverse */
	LCD_writecmd(0b11000000, i); /* COM normal */
	LCD_writecmd(0b10100110, i); /* INV off */
	LCD_writecmd(0b10100010, i); /* 1/9 bias */
	LCD_writecmd(0b00101111, i); /* Booster, regulator, follower ON */
	LCD_writecmd(0b11111000, i); /* Set internal booster to 4x */
	LCD_writecmd(0b00000000, i); /* Set internal booster to 4x */
	LCD_writecmd(0b00100111, i); /* Contrast */
	LCD_writecmd(0b10000001, i); /* Contrast */
	LCD_writecmd(0b00010000, i); /* Contrast */
	LCD_writecmd(0b10101100, i); /* No indicator */
	LCD_writecmd(0b00000000, i); /* No indicator */
	LCD_writecmd(0b10101111, i); /* Display ON */
/* Above is for DOGL display */
}
#endif

#ifdef N3310
for(unsigned char i = 1; i < 2; i++){
    LCD_writecmd( 0x21, i);  // LCD Extended Commands.
    LCD_writecmd( contrast, i );  // Set LCD Vop (Contrast), range 0xBB to 0xDD
    LCD_writecmd( 0x04, i );  // Set Temp coefficent.
    LCD_writecmd( 0x13, i );  // LCD bias mode 1:48.
    LCD_writecmd( 0x20, i );  // LCD Standard Commands, Horizontal addressing mode.
    if(!neg)LCD_writecmd( 0x0C, i );  // LCD in normal mode.
    if(neg)LCD_writecmd( 0x0D, i );  // LCD in reverse mode.
}
#endif    

LCD_clear(1);
LCD_clear(2);
	

}


unsigned char FB_readdata(void)	
{
   unsigned char data = fb[FB_xpos][FB_ypos];   
   
   return data;
}


void FB_drawdot(unsigned char x, unsigned char y)	
{
   FB_setxy(x, y/8);
   unsigned char tempdata = FB_readdata();
   tempdata = FB_readdata();
   FB_setxy(x, y/8);
   FB_writedata(tempdata | (1<<(y % 8)));
}


void FB_cleardot(unsigned char x, unsigned char y)	
{
   FB_setxy(x, y/8);
   unsigned char tempdata = FB_readdata();
   tempdata = FB_readdata();
   FB_setxy(x, y/8);
   FB_writedata(tempdata & ~(1<<(y % 8)));

}


void FB_drawline(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char clr)
{
   char deltax = abs(x2 - x1);
   char deltay = abs(y2 - y1);
   char x = x1;
   char y = y1;
   char xinc1;
   char xinc2;
   char yinc1;
   char yinc2;
   char den;
   char num;
   char numadd;
   char numpixels;

   if (x2 >= x1)
   {
      xinc1 = 1;
      xinc2 = 1;
   }
   
   else
   {
      xinc1 = -1;
      xinc2 = -1;
   }

   if (y2 >= y1)
   {
      yinc1 = 1;
      yinc2 = 1;
   }
   
   else
   {
      yinc1 = -1;
      yinc2 = -1;
   }

   if (deltax >= deltay)
   {
      xinc1 = 0;
      yinc2 = 0;
      den = deltax;
      num = deltax / 2;
      numadd = deltay;
      numpixels = deltax;
   }
   
   else
   {
      xinc2 = 0;
      yinc1 = 0;
      den = deltay;
      num = deltay / 2;
      numadd = deltax;
      numpixels = deltay;
   }

   for (unsigned char curpixel = 0; curpixel <= numpixels; curpixel++)
   {
      if (clr)
      {
         FB_cleardot(x, y);
      }
      
      else
      {
         FB_drawdot(x, y);
      }
      
      num += numadd;
      
      if (num >= den)
      {
         num -= den;
         x += xinc1;
         y += yinc1;
      }
      
      x += xinc2;
      y += yinc2;
   }
}


void FB_drawrect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char fill, unsigned char clr)
{
   if (fill != 0)
   {
      for (int i = y1; i <= y2; i++)
      {
         FB_drawline(x1, i, x2, i, clr);
      }
   }
   
   else
   {
      FB_drawline(x1, y1, x2, y1, clr);
      FB_drawline(x1, y2, x2, y2, clr);
      FB_drawline(x2, y1, x2, y2, clr);
      FB_drawline(x1, y1, x1, y2, clr);
   }
}


void FB_drawcircle(unsigned char x1, unsigned char y1, unsigned char radius)
{
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;

   FB_drawdot(x1, y1 + radius);
   FB_drawdot(x1, y1 - radius);
   FB_drawdot(x1 + radius, y1);
   FB_drawdot(x1 - radius, y1);

   while(x < y)
   {
      if(f >= 0)
      {
         y--;
         ddF_y += 2;
         f += ddF_y;
      }
      
      x++;
      ddF_x += 2;
      f += ddF_x + 1;   
      FB_drawdot(x1 + x, y1 + y);
      FB_drawdot(x1 - x, y1 + y);
      FB_drawdot(x1 + x, y1 - y);
      FB_drawdot(x1 - x, y1 - y);
      FB_drawdot(x1 + y, y1 + x);
      FB_drawdot(x1 - y, y1 + x);
      FB_drawdot(x1 + y, y1 - x);
      FB_drawdot(x1 - y, y1 - x);
   }
}


void FB_drawbargraph(unsigned char xpos, unsigned char ypos, unsigned char length, unsigned char height, unsigned char fill){
	FB_drawrect(xpos, ypos, xpos+length, ypos+height, 0, 0);
	if(fill) FB_drawrect(xpos+1, ypos+1, xpos+((fill*length)/100), ypos+height-1, 1, 0);

}


void bktcontrol(void)
{

if(bkttimer){
   bkttimer--;
   BKT_PORT |= (1<<BKT_PIN);
   }
if(!bkttimer){
   BKT_PORT &= ~(1 << BKT_PIN);
   }
}
